Global ("MPanel", nil)
Global ("MText", nil)
Global ("Avaid", nil)

--  ALT+Z
function OnToggleUI( params )
	if params.visible then
		MPanel:Show( true )
		MText:Show( true )
		DnD:Reg( MPanel )
	else
		DnD:Unreg( MPanel )
		MPanel:Show( false )
		MText:Show( false )
	end
end

--------------------------------------------------------------------------------
function SetDScount()
    local function GetDScount()
        if avatar.IsExist() then
            local ds = unit.GetEquipmentItemId(avatar.GetId(), DRESS_SLOT_DEATHINSURANCE, ITEM_CONT_EQUIPMENT)
            return ds and avatar.GetItemInfo(ds).stackCount or 0
        end
        return 0
    end

    local cnt = GetDScount()

    --MText:ClearValues()
    MText:SetVal( "ds_gvalue", common.GetEmptyWString ())
    MText:SetVal( "ds_rvalue", common.GetEmptyWString ())
    MText:SetVal( "ds_yvalue", common.GetEmptyWString ())

    if cnt > 20 then
        MText:SetVal( "ds_gvalue", common.FormatInt(cnt,"%d"))
    elseif cnt < 4 then
        MText:SetVal( "ds_rvalue", common.FormatInt(cnt,"%d"))
    else
        MText:SetVal( "ds_yvalue", common.FormatInt(cnt,"%d"))
    end
end
--------------------------------------------------------------------------------
function SetMyrrhcount()
    local function GetMyrrhcount()
		if avatar.IsExist() then
            local ids = avatar.GetCurrencies()
			local myrrhId = avatar.GetCurrencyId( "myrrh" )
			if myrrhId then
                local info = avatar.GetCurrencyInfo( myrrhId )
                if info then
                    return info.value
                end
			end
		end
        return 0
    end

    local cnt = GetMyrrhcount()
    MText:SetVal( "my_gvalue", common.GetEmptyWString ())
    MText:SetVal( "my_rvalue", common.GetEmptyWString ())
    MText:SetVal( "my_yvalue", common.GetEmptyWString ())
                               
    --LogInfo( "GetMyrrhcount: ", cnt )
    
    if cnt > 1000 then
        MText:SetVal( "my_gvalue", common.FormatInt(cnt,"%d"))
    elseif cnt < 200 then
        MText:SetVal( "my_rvalue", common.FormatInt(cnt,"%d"))
    else
        MText:SetVal( "my_yvalue", common.FormatInt(cnt,"%d"))
    end
end
--------------------------------------------------------------------------------
function SetMountFeedcount()
    local function GetMountFeedcount()
        if avatar.IsExist() then
            local mounts = mount.GetMounts()
			local stableInfo = mount.GetStableInfo()
			if stableInfo then
				return stableInfo.foodCount
			end 
        end
        return 0
    end

    local cnt = GetMountFeedcount()
    --LogInfo( "GetMountFeedcount: ", cnt )
    MText:SetVal( "mo_gvalue", common.GetEmptyWString ())
    MText:SetVal( "mo_rvalue", common.GetEmptyWString ())
    MText:SetVal( "mo_yvalue", common.GetEmptyWString ())
                               
    if cnt > 5 then
        MText:SetVal( "mo_gvalue", common.FormatInt(cnt,"%d"))
    elseif cnt < 2 then
        MText:SetVal( "mo_rvalue", common.FormatInt(cnt,"%d"))
    else
        MText:SetVal( "mo_yvalue", common.FormatInt(cnt,"%d"))
    end
end
--------------------------------------------------------------------------------
function SetMountHungry()
    local function GetMountHungry()
        if avatar.IsExist() then
            --local activeId = mount.GetActive() 
            --if activeId then 
            --    local mountInfo = mount.GetInfo(activeId) 
            --    if mountInfo then 
            --        return math.ceil(mount.GetActiveSatiation() / 60000)
            --    end
            --end
            local mountInfo = mount.GetInfo(mount.GetMounts() [0]) 
            if mountInfo then 
                return math.ceil(mountInfo.satiationMs / 60000)
            end
        end
        return 0
    end

    local cnt = GetMountHungry()
    --LogInfo( "GetMountHungry: ", cnt )
    MText:SetVal( "motime_gvalue", common.GetEmptyWString ())
    MText:SetVal( "motime_rvalue", common.GetEmptyWString ())
    MText:SetVal( "motime_yvalue", common.GetEmptyWString ())
                               
    if cnt > 20 then
        MText:SetVal( "motime_gvalue", common.FormatInt(cnt,"%d"))
    elseif cnt < 2 then
        MText:SetVal( "motime_rvalue", common.FormatInt(cnt,"%d"))
    else
        MText:SetVal( "motime_yvalue", common.FormatInt(cnt,"%d"))
    end
end
--------------------------------------------------------------------------------
-- EVENT_AVATAR_CREATED
function OnEventAvatarCreated( params )
    SetDScount()
    SetMyrrhcount()
    SetMountFeedcount()
    SetMountHungry()
    
    Avaid = avatar.GetId()
end

-- EVENT_UNIT_DEAD_CHANGED
function OnEventUnitDeadChanged( params )
    if params.unitId == Avaid then
        SetDScount()
    end
end

-- EVENT_ITEM_RECEIVED - EVENT_ITEM_LOST
function OnEventItemChanged( params )
    SetDScount()
end

-- EVENT_CURRENCY_VALUE_CHANGED
function OnEventCurrencyValueChanged( params )
	SetMyrrhcount()
	SetMountFeedcount()
end

-- EVENT_UNIT_MOUNT_HEALTH_CHANGED
function OnEventMountHealthChanged( params )
	SetMountHungry()
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
    common.RegisterEventHandler( OnToggleUI,                    "SCRIPT_TOGGLE_UI")
	common.RegisterEventHandler( OnEventAvatarCreated,          "EVENT_AVATAR_CREATED" )
	common.RegisterEventHandler( OnEventUnitDeadChanged,        "EVENT_UNIT_DEAD_CHANGED" )
	common.RegisterEventHandler( OnEventItemChanged,            "EVENT_INVENTORY_ITEM_REMOVED" )
	common.RegisterEventHandler( OnEventItemChanged,            "EVENT_INVENTORY_ITEM_ADDED" )
	common.RegisterEventHandler( OnEventCurrencyValueChanged,   "EVENT_CURRENCY_VALUE_CHANGED" )
	common.RegisterEventHandler( OnEventMountHealthChanged,     "EVENT_UNIT_MOUNT_HEALTH_CHANGED" )
    common.RegisterEventHandler( OnEventMountHealthChanged,     "EVENT_SECOND_TIMER" )

    MPanel = mainForm:GetChildUnchecked("MPanel", false)
    MText = MPanel:GetChildUnchecked("MText", false)
	
	DnD:Init( 914, MPanel, MPanel, true )
end

--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------